package com.fossgalaxy.games.tbs.editor;

import com.fossgalaxy.games.tbs.editor.EditorView.EditorModel;
import com.fossgalaxy.games.tbs.io.SettingsIO;
import com.fossgalaxy.games.tbs.io.map2.MapDef;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.io.File;

public class OpenAction extends AbstractAction {
    private SettingsIO io;
    private EditorModel model;

    public OpenAction(SettingsIO io, EditorModel model) {
        super("open");
        this.io = io;
        this.model = model;
    }

    @Override
    public void actionPerformed(ActionEvent actionEvent) {

        String filePath = model.getDefaultFilePath();
        if (filePath == null) {
            filePath = System.getProperty("user.dir");
        }

        JFileChooser fc = new JFileChooser(filePath);

        JsonFileFilter filer = new JsonFileFilter();
        fc.addChoosableFileFilter(filer);
        fc.setFileFilter(filer);

        int ret = fc.showOpenDialog(null);

        if (ret == JFileChooser.APPROVE_OPTION) {

            File f = fc.getSelectedFile();
            model.setDefaultFilePath(f.getParent());

            MapDef def = io.loadMapDef(f.getAbsolutePath());
            model.setMapDef(def);
        }

    }
}
